/*
 * jQuery Image Slider 1.0
 * 
 * [Slider]
 * 
 * NO COPYRIGHTS OR LICENSES. DO WHAT YOU LIKE.
 * 
 * http://digipiph.com
 * 
 * File generated: Tue Oct 19 12:25 EST 2010
 */
(function($){
      
  //START $.fn.imageSlider
  $.fn.imageSlider = function (instanceSettings) {
  	
	//settings
	var defaultSettings = {
      imageshowWidth:			  400,
	  imageshowHeight:			  320,
	  thumbWidth:                 200,
	  thumbHeight:                200,
	  startingSlide:                1,
	  slideSpacing:                20,
	  slideSpeed:            'medium',
	  titles:                   false, //above,below,false
	  background:              '#FFF',
	  leftNavImg:    'left-arrow.jpg',
	  rightNavImg:   'right-arrow.jpg'
    };
  
    
	
	/***********************
	//General Configuring (Global Variables)
	***********************/
	
	// get the defaults or any user set options
	var settings = $.extend(defaultSettings, instanceSettings);					
	  	
	//general info about the slider
	var currentSlider = this.attr('id');
    var slides = $('#'+currentSlider+' .slide');
    var numberOfSlides = slides.length;
	var ttlSlidesWidth = 0;
	
	
	
	/***********************
	//Image Configuring
	//Scale every image to thumbnails
	***********************/
	
	//make sure all the images are loaded first before doing anything
	$(window).load(function() {
	  slides.each(function(){
	  	  	  
	    var ratio = 0;  // Used for aspect ratio
        var imgWidth = $(this).width();    // Current image width
        var imgHeight = $(this).height();  // Current image height
	  
	    //START: Scale Thumbnail
		
		  // Check if the current width is larger than the max
          if(imgWidth > settings.thumbWidth) {
		    ratio = settings.thumbWidth / imgWidth;   // get ratio for scaling image
            $(this).width(settings.thumbWidth); // Set new width
            $(this).height(imgHeight * ratio);  // Scale height based on ratio
            imgWidth = settings.thumbWidth;   // Reset width to match scaled image
			imgHeight = imgHeight * ratio;    // Reset height to match scaled image
          }
	      // Check if current height is larger than max
          if(imgHeight > settings.thumbHeight){
		    ratio = settings.thumbHeight / imgHeight; // get ratio for scaling image
            $(this).height(settings.thumbHeight);   // Set new height
            $(this).width(imgWidth * ratio);    // Scale width based on ratio
			imgWidth = imgWidth * ratio;   // Reset width to match scaled image
			imgHeight = settings.thumbHeight;    // Reset height to match scaled image
          }
		
		  //END: Scale Thumbnail
		  
		  //Add the titles to the slides
		  if (settings.titles) {
		    if (settings.titles == 'above') { 
		      $(this).wrap('<div class="slideWrapper">');
			  $(this).parent().prepend('<div class="title">'+$(this).attr('title')+'</div><br />');
		    }
			
		    if (settings.titles == 'below') {
			  $(this).wrap('<div class="slideWrapper">');
			  $(this).parent().append('<br /><div class="title">'+$(this).attr('title')+'</div>');
		    }  
		  }
	  
	  }); //end slide.each
	  
	  //set slides to the new wrapper
	  if (settings.titles) slides = $('#'+currentSlider+' .slideWrapper');
		
	
	
	  /***********************
	  //imageSlider Styling
	  ***********************/
		  
	  $('#'+currentSlider).css({
	    'width'      : settings.imageshowWidth+'px',
		'height'     : settings.imageshowHeight+'px',
		'background' : settings.background,
		'overflow'   : 'hidden',
		'position'   : 'relative'
	  });
	
	  slides.css({ 
	    'float'        : 'left',
		'width'        : settings.thumbWidth+'px',
		'margin-left'  : settings.slideSpacing+'px',
		'margin-right' : settings.slideSpacing+'px',
		'margin-top'    : '0px',
		'margin-bottom' : '0px',
		'text-align'   : 'center'
      });
	  
	  //configure the slide container so it holds all the slides (including the spacing)
	  slides.each(function(){
	    ttlSlidesWidth += $(this).width() + (settings.slideSpacing * 2);
	  });
	  
	  //find the starting point
	  var startingDistance = settings.imageshowWidth/2;
	  startingDistance -= settings.thumbWidth/2;
	  startingDistance -= settings.slideSpacing;
	  
	  if(settings.startingSlide > 1 && settings.startingSlide <= numberOfSlides) {
	    startingDistance -= (settings.thumbWidth + (settings.slideSpacing* 2)) * (settings.startingSlide - 1);   
	  }
	  
	  //center vertically
	  var verticleDistance = settings.imageshowHeight/2;
	  verticleDistance -= settings.thumbHeight/2;
	  if (settings.titles == 'below') verticleDistance -= 15;
	  		
	  $('#'+currentSlider+' .slidesContainer').css({
	      'position' : 'absolute',
		  'overflow' : 'hidden',
		  'left'     : startingDistance+'px',
		  'top'      : verticleDistance+'px',
		  'width'    : ttlSlidesWidth+'px'
	  });
	  	  
	}); //end $(window).load
	


	
	/***********************
	//Controls
	***********************/
	
	//build the control objects
	this.append('<div class="controlLeft"><img src="'+settings.leftNavImg+'"></div><div class="controlRight"><img src="'+settings.rightNavImg+'"></div>');
	
	//add styles to the controls
	$('#'+currentSlider+' .controlLeft').css({
	    'position' : 'absolute',
		'top'      : settings.imageshowHeight/2+'px',
		'left'     : '0px',
		'cursor'   : 'pointer',
		'z-index'  : 1
	});
	$('#'+currentSlider+' .controlRight').css({
	    'position' : 'absolute',
		'top'      : settings.imageshowHeight/2+'px',
		'right'    : '0px',
		'cursor'   : 'pointer',
		'z-index'  : 1
	});
	
	//set the speed for how fast the slider will move
	switch(settings.slideSpeed) {
		case"slow": slidingspeed = 5; break;
		case"medium": case"default": slidingspeed = 10; break;
		case"fast": slidingspeed = 15; break;
	}
	
	//add Click functionality to controls after the window has loaded	
	$(window).load(function() {
	  
	  var timer = 0;
	  $('#'+currentSlider+' .controlLeft').mousedown(function(){
	    timer = setInterval(function() {
		  
		  //don't slide too far...
		  if ($('#'+currentSlider+' .slidesContainer').position().left <= (settings.imageshowWidth/2) - (settings.thumbWidth/2) - settings.slideSpacing) {
		    $('#'+currentSlider+' .slidesContainer').animate({ left:'+='+slidingspeed }, 1);
		  }
		  
		}, 30);
	  }).bind('mouseup mouseleave', function() {
		  clearInterval(timer);
	  });
	  $('#'+currentSlider+' .controlRight').mousedown(function(){
	    timer = setInterval(function() {
		  
		  //don't slide too far...
		  if ($('#'+currentSlider+' .slidesContainer').position().left >= ((ttlSlidesWidth - (settings.imageshowWidth/2) - (settings.thumbWidth/2) - settings.slideSpacing)* -1)) {
		    $('#'+currentSlider+' .slidesContainer').animate({ left:'-='+slidingspeed }, 1);
		  }
		  
		}, 30);
	  }).bind('mouseup mouseleave', function() {
		  clearInterval(timer);
	  });
	  
	}); //end $(window).load
	
	
	
	/***********************
	//Public Helper Functions
	//Called by $('#object_id').functionName(vars);
	***********************/
	
	$.fn.goToSlide = function(slide) {
	  var slideDistance = settings.imageshowWidth/2;
	  slideDistance -= settings.thumbWidth/2;
	  slideDistance -= settings.slideSpacing;
	  
	  if(slide > 1 && slide <= numberOfSlides) {
	    slideDistance -= (settings.thumbWidth + (settings.slideSpacing* 2)) * (slide - 1);   
	  }
	  
	  $('#'+currentSlider+' .slidesContainer').animate({
		  'left'     : slideDistance+'px'
	  },500);
	  
	};
		
  }
  //END $.fn.Slider
    
})(jQuery)